/*
 *  Copyright (c) 2021 NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NetAppVolumeSnapshotLister helps list NetAppVolumeSnapshots.
// All objects returned here must be treated as read-only.
type NetAppVolumeSnapshotLister interface {
	// List lists all NetAppVolumeSnapshots in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeSnapshot, err error)
	// NetAppVolumeSnapshots returns an object that can list and get NetAppVolumeSnapshots.
	NetAppVolumeSnapshots(namespace string) NetAppVolumeSnapshotNamespaceLister
	NetAppVolumeSnapshotListerExpansion
}

// netAppVolumeSnapshotLister implements the NetAppVolumeSnapshotLister interface.
type netAppVolumeSnapshotLister struct {
	indexer cache.Indexer
}

// NewNetAppVolumeSnapshotLister returns a new NetAppVolumeSnapshotLister.
func NewNetAppVolumeSnapshotLister(indexer cache.Indexer) NetAppVolumeSnapshotLister {
	return &netAppVolumeSnapshotLister{indexer: indexer}
}

// List lists all NetAppVolumeSnapshots in the indexer.
func (s *netAppVolumeSnapshotLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeSnapshot, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppVolumeSnapshot))
	})
	return ret, err
}

// NetAppVolumeSnapshots returns an object that can list and get NetAppVolumeSnapshots.
func (s *netAppVolumeSnapshotLister) NetAppVolumeSnapshots(namespace string) NetAppVolumeSnapshotNamespaceLister {
	return netAppVolumeSnapshotNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NetAppVolumeSnapshotNamespaceLister helps list and get NetAppVolumeSnapshots.
// All objects returned here must be treated as read-only.
type NetAppVolumeSnapshotNamespaceLister interface {
	// List lists all NetAppVolumeSnapshots in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeSnapshot, err error)
	// Get retrieves the NetAppVolumeSnapshot from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NetAppVolumeSnapshot, error)
	NetAppVolumeSnapshotNamespaceListerExpansion
}

// netAppVolumeSnapshotNamespaceLister implements the NetAppVolumeSnapshotNamespaceLister
// interface.
type netAppVolumeSnapshotNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NetAppVolumeSnapshots in the indexer for a given namespace.
func (s netAppVolumeSnapshotNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeSnapshot, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppVolumeSnapshot))
	})
	return ret, err
}

// Get retrieves the NetAppVolumeSnapshot from the indexer for a given namespace and name.
func (s netAppVolumeSnapshotNamespaceLister) Get(name string) (*v1alpha1.NetAppVolumeSnapshot, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("netappvolumesnapshot"), name)
	}
	return obj.(*v1alpha1.NetAppVolumeSnapshot), nil
}
