/*
 *  Copyright (c) 2021 NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NodevolSetLister helps list NodevolSets.
// All objects returned here must be treated as read-only.
type NodevolSetLister interface {
	// List lists all NodevolSets in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NodevolSet, err error)
	// NodevolSets returns an object that can list and get NodevolSets.
	NodevolSets(namespace string) NodevolSetNamespaceLister
	NodevolSetListerExpansion
}

// nodevolSetLister implements the NodevolSetLister interface.
type nodevolSetLister struct {
	indexer cache.Indexer
}

// NewNodevolSetLister returns a new NodevolSetLister.
func NewNodevolSetLister(indexer cache.Indexer) NodevolSetLister {
	return &nodevolSetLister{indexer: indexer}
}

// List lists all NodevolSets in the indexer.
func (s *nodevolSetLister) List(selector labels.Selector) (ret []*v1alpha1.NodevolSet, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NodevolSet))
	})
	return ret, err
}

// NodevolSets returns an object that can list and get NodevolSets.
func (s *nodevolSetLister) NodevolSets(namespace string) NodevolSetNamespaceLister {
	return nodevolSetNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NodevolSetNamespaceLister helps list and get NodevolSets.
// All objects returned here must be treated as read-only.
type NodevolSetNamespaceLister interface {
	// List lists all NodevolSets in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NodevolSet, err error)
	// Get retrieves the NodevolSet from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NodevolSet, error)
	NodevolSetNamespaceListerExpansion
}

// nodevolSetNamespaceLister implements the NodevolSetNamespaceLister
// interface.
type nodevolSetNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NodevolSets in the indexer for a given namespace.
func (s nodevolSetNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NodevolSet, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NodevolSet))
	})
	return ret, err
}

// Get retrieves the NodevolSet from the indexer for a given namespace and name.
func (s nodevolSetNamespaceLister) Get(name string) (*v1alpha1.NodevolSet, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("nodevolset"), name)
	}
	return obj.(*v1alpha1.NodevolSet), nil
}
